#!/usr/bin/perl

#####################################################################
#楽天ショップ受注状況表示プログラム「猛烈行列」Ver.1.11
#(c)かんいちソフトウェア	http://www.kan-1.net/
#このプログラムの無断転載・転売等を禁じます。
#別途定める利用規約に同意したものとみなします。
#プログラムを改編した場合はサポートいたしかねますのでご了承ください。
#####################################################################

use strict;
use Net::POP3;
use MIME::Parser;
use MIME::Words qw(decode_mimewords);
use Encode qw(from_to);
use LWP::Simple;
use Net::FTP;
use CGI::Carp qw(fatalsToBrowser);
use FindBin;
our $dir = $FindBin::Bin;
require "$dir/cfg.cgi" ;

our $dbg = 0 ;

if(!$cfg::start_cron){
	print "Content-Type: image/gif\n\n\x47\x49\x46\x38\x39\x61\x01".
		"\x00\x01\x00\x80\xff\x00\xff\xff\xff\x00\x00\x00\x21\xf9".
		"\x04\x01\x00\x00\x00\x00\x2c\x00\x00\x00\x00\x01\x00\x01".
		"\x00\x00\x02\x02\x44\x01\x00\x3b";
	close(STDOUT);
	close(STDERR);
}
our $print ;
my $hit = &recieve_mail();
$print .= "新規注文：$hit件\n" ;
my $html ;
my $loop_html ;
if($hit){
	my $lfh = my_flock() or die"lock error." ;
	open my $fh , "$dir/$cfg::temp_file" ;
	for(<$fh>){
		$html .= $_ ;
	}
	close $fh ;
	if($cfg::charset ne 'utf8'){
		from_to($html,$cfg::charset,'utf-8');
	}
	my $temp_line ;
	if($html =~ m!<\$loop\-begin\$>(.+?)<\$loop\-end\$>!s){
		$temp_line = $1 ;
	}
	open my $fh , "$dir/$cfg::order_csv" ;
	my $count = 0 ;
	for(<$fh>){
		chomp;
		my $temp_line2 = $temp_line ;
		my @order_data = split /\t/ , $_ ;
		if($cfg::disp_date){
			$temp_line2 =~ s/<\$date\$>/$order_data[1]/g ;
		}
		if($cfg::disp_product){
			$order_data[2] =~ s/"/&quot;/g ;
			$order_data[2] =~ s/</&lt;/g ;
			$order_data[2] =~ s/>/&gt;/g ;
			$temp_line2 =~ s/<\$product\$>/$order_data[2]/g ;
		}
		if($cfg::disp_price){
			$temp_line2 =~ s/<\$price\$>/$order_data[4]/g ;
		}
		if($cfg::disp_pref){
			$temp_line2 =~ s/<\$pref\$>/$order_data[5]/g ;
		}
		if($cfg::disp_thumbnail){
			$temp_line2 =~ s/<\$thumbnail\$>/$order_data[6]/g ;
		}
		if($cfg::disp_url){
			$temp_line2 =~ s/<\$url\$>/$order_data[7]/g ;
		}
		$temp_line2 =~ s/<\$[^<>]+?\$>//g ;
		$loop_html .= $temp_line2 ;
		++$count;
		if($count >= $cfg::max_disp){
			last;
		}
	}
	close $fh ;
	$html =~ s/<\$loop-begin\$>.+?<\$loop-end\$>/$loop_html/sg ;
	if($cfg::disp_update){
		my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
		my $update = sprintf("最終更新：%04d/%02d/%02d %02d:%02d", $year + 1900, $mon +1, $mday, $hour, $min);
		$html =~ s/<\$update\$>/$update/g ;
	}
	$html =~ s/<\$[^<>]+?\$>//g ;
	if($cfg::charset ne 'utf8'){
		from_to($html,'utf-8',$cfg::charset);
	}
	open my $fh , ">" , "$dir/$cfg::html_file" ;
	print $fh $html ;
	close $fh ;
	my_funlock($lfh);
	my $ftp ;
	if($dbg){
		$ftp = Net::FTP->new("$cfg::ftp_server", Passive => 1, Timeout => 300) or die "ftp error.";
	}else{
		$ftp = Net::FTP->new("$cfg::ftp_server", Port => 16910, Passive => 1, Timeout => 300) or die "ftp error.";
	}
	$ftp->login($cfg::ftp_user, $cfg::ftp_pass) or die "ftp error.";
	$ftp->binary();
	$ftp->cwd($cfg::ftp_dir) or die "ftp error.";
	$ftp->put("$dir/$cfg::html_file") or die "ftp error.";
	$ftp->quit;
	
}
if($cfg::start_cron){
	from_to($print,'utf-8','shiftjis');
	if($dbg){
		print "Content-Type: text/plain\n\n";
	}
	print $print ;
}
exit;

sub recieve_mail {
my $hit = 0 ;
my $objPop3 = eval{ Net::POP3->new($cfg::pop_server) or die "mail error."; };
if(!$objPop3){
	if(substr($@,0,3) eq 'ERR'){
		$print .= "接続できませんでした。" ;
	}
	else {
		$print .= $@;
	}
	return();
}
my $objParse = new MIME::Parser;
$objParse->output_to_core(1);
my $nMessage = $objPop3->login($cfg::pop_user,$cfg::pop_pass);
$print .= sprintf "メッセージ数：%d件\n" , $nMessage ;
my $msgid = $objPop3->list();
my %sortdata;
foreach my $key( keys %$msgid ){
	$sortdata{sprintf("%03d", 1000 - $key)} = $$msgid{$key};
}
my $mail_count = 0 ;
foreach my $key( sort keys %sortdata ){
	++$mail_count ;
	if($mail_count >= $cfg::max_mail){
		last;
	}
	my $value = $sortdata{$key};
	$key = 1000 - $key;
	my $objMail = $objPop3->get($key);
	my $entity = $objParse->parse_data($objMail);
	my $head = $entity->head;
	my $from = $head->get('From');
	chomp($from);
	if($from !~ /$cfg::from_address/){
		if($cfg::delete_mail){
			$objPop3->delete($key);
		}
		$print .= "【例外メール】送信者：$from\n" ;
		next;
	}
	my $to = $head->get('To');
	chomp($to);
	my $subject = $head->get('Subject');
	chomp($subject);
	my @decode = decode_mimewords( $subject );
	my $text = "";
	foreach my $data( @decode ){
		my ($target,$charset) = @$data;
		from_to($target,'jis','utf8');
		$target =~ s/\n//g;
		$text .= $target
	}
	if($text !~ /注文内容ご確認/){
		if($cfg::delete_mail){
			$objPop3->delete($key);
		}
		$print .= "【例外メール】件名：$text\n" ;
		next;
	}
	my $body = $entity->bodyhandle;
	my $body_data = $body->as_string;
	from_to($body_data,'jis','utf8');
	$body_data =~ s/^\s+//;
	$body_data =~ s/\s+$//;
	if($cfg::delete_mail){
		$objPop3->delete($key);
	}
	my $ordernum ;
	my $date ;
	my $pref ;
	if($body_data =~ m!\[受注番号\] ([\d\-]+?)\n!s){
		$ordernum = $1 ;
	}
	if($body_data =~ m!\[日時\]     ([\d\-\: ]+?)\n!s){
		$date = $1 ;
		$date =~ s/\-/\//g ;
	}
	if($body_data =~ m!\[注文者\][^\n]+?様\n[^\n]+?〒[\d\-]+? ([^\n]+?)\n[^\n]+?\(TEL\)!s){
		$pref = &check_pref($1);
	}
	my $lfh = my_flock() or die"lock error." ;
	my $on_hit = 0 ;
	my @order ;
	open my $fh , "$dir/$cfg::order_csv" ;
	#注文データを読み込みながら受注番号重複チェック
	for(<$fh>){
		chomp;
		my @order_data = split /\t/ , $_ ;
		if($order_data[0] eq $ordernum){
			$on_hit = 1 ;
			last;
		}
		push @order , "$_\n" ;
	}
	close $fh ;
	if($on_hit){ 
		my_funlock($lfh);
		next;
	}
	while($body_data =~ m!(?:\n\[商品\]|\n\-\-\-\-\-\-\-\-\-\-)\n([^\n]+?)\n.*?価格  ([\d,]+?)\(円\) x \d+?\([^\(\)]+?\) = [\d,]+?\(円\)!sg){
		my $product = $1 ;
		my $price = $2 ;
		my $q ;
		my $code ;
		if($product =~ m!^(.+?)\(([^\(\)]+?)\)$!){
			$q = $1 ;
			$code = $2 ;
		}else{
			$q = $product ;
		}
		$price =~ s/,//g ;
		$q =~ s/\r/ /g ;
		$q =~ s/\n/ /g ;
		$q =~ s/\//／/g ;
		$q =~ s/\[送付先\].+?\[商品\]//g ;
		$q =~ s/([^\w ])/'%'.unpack('H2', $1)/eg;
		$q =~ tr/ /+/;
		my $search_url = 'http://search.rakuten.co.jp/search/inshop-mall/' . $q . '/-/sid.' . $cfg::sid . '-st.A' ;
		my $html = get($search_url) ;
		my $search_result ;
#		open DBG ,">dbg.html" ;
#		print DBG $html ;
#		close DBG ;
		if($html =~ m!<\!\-\- search result list \-\->(.+?)<\!\-\- // search result list \-\->!s){
			$search_result = $1 ;
		}
		my $url ;
		my $thumbnail ;
		if($search_result =~ m!<div style="overflow\:hidden;width\:96px;"><a href="(http[^"]+?)" target="_top"><img alt="[^"]+?" border="0" src="(http://thumbnail\.image\.rakuten\.co\.jp/[^"]+?)" ></a></div>!){
			$url = $1 ;
			$thumbnail = $2 ;
		}else{
			if(!$code){
				$print .= "商品コードが見つかりません。\n" ;
				next;
			}
			$code =~ s/\-/－/g ;
			my $search_url = 'http://search.rakuten.co.jp/search/inshop-mall/' . $code . '/-/sid.' . $cfg::sid . '-st.A' ;
			my $html = get($search_url) ;
			my $search_result ;
			if($html =~ m!<\!\-\- search result list \-\->(.+?)<\!\-\- // search result list \-\->!s){
				$search_result = $1 ;
			}
			if($search_result =~ m!<div style="overflow\:hidden;width\:96px;"><a href="(http[^"]+?)" target="_top"><img alt="[^"]+?" border="0" src="(http://thumbnail\.image\.rakuten\.co\.jp/[^"]+?)" ></a></div>!){
				$url = $1 ;
				$thumbnail = $2 ;
			}
		}
		unshift @order , "$ordernum\t$date\t$product\t$code\t$price\t$pref\t$thumbnail\t$url\n" ;
		++$hit;
	}
	open my $fh , ">" , "$dir/$cfg::order_csv" ;
	my $num = 0 ;
	for(@order){
		print $fh $_ ;
		++$num ;
		if($num >= $cfg::max_csv){
			last;
		}
	}
	close $fh ;
	my_funlock($lfh);
}
$objPop3->quit;
return($hit);
}

sub check_pref {
my $address = shift ;
my @pref = ("北海道","青森県","岩手県","秋田県","宮城県","山形県","福島県","茨城県","栃木県","群馬県","埼玉県","千葉県","東京都","神奈川県","山梨県","長野県","新潟県","富山県","石川県","福井県","静岡県","愛知県","岐阜県","三重県","滋賀県","京都府","大阪府","兵庫県","奈良県","和歌山県","島根県","鳥取県","岡山県","広島県","山口県","香川県","徳島県","高知県","愛媛県","福岡県","佐賀県","長崎県","大分県","熊本県","宮崎県","鹿児島県","沖縄県");
for(@pref){
	if($address =~ /$_/){
		return($_);
	}
}
return();
}

sub my_flock {
my %lfh = (dir => "$dir/lock/", basename => "lockfile", timeout => 30, trytime => 10, @_);
$lfh{path} = $lfh{dir} . $lfh{basename};
for(my $i = 0; $i < $lfh{trytime}; $i++, sleep 1){
	return \%lfh if(rename($lfh{path}, $lfh{current} = $lfh{path} . time));
}
opendir(LOCKDIR, $lfh{dir});
my @filelist = readdir(LOCKDIR);
closedir(LOCKDIR);
foreach(@filelist){
	if(/^$lfh{basename}(\d+)/){
		return \%lfh if(time - $1 > $lfh{timeout} and rename($lfh{dir} . $_, $lfh{current} = $lfh{path} . time));
		last;
	}
}
undef;
}

sub my_funlock {
rename($_[0]->{current}, $_[0]->{path});
}


