package cfg;

#####################################################################
#楽天ショップ受注状況表示プログラム「猛烈行列」
#(c)かんいちソフトウェア	http://www.kan-1.net/
#このプログラムの無断転載・転売等を禁じます。
#別途定める利用規約に同意したものとみなします。
#プログラムを改編した場合はサポートいたしかねますのでご了承ください。
#####################################################################

##◆受注メール受信設定

#POP3サーバー
our $pop_server = 'pop.mail.net' ;

#メールアカウント
our $pop_user = 'username' ;

#パスワード
our $pop_pass = 'password';

#受注メールを受信後サーバーから削除するなら「1」、しないなら「0」（「猛烈行列」専用メールアドレスの場合は「1」にしてください）
our $delete_mail = 0 ;

#一度にメールを読み込む件数の上限（20～50程度）
our $max_mail = 20 ;

#受注メール送信者アドレス（下記以外のアドレスからのメールは無視されます）
our $from_address = 'order@rakuten.co.jp' ;

#◆HTML書き出し設定

#HTMLファイル名
our $html_file = 'order.html' ;

#出力文字コード（shiftjis、utf8、euc-jp）
our $charset = 'euc-jp' ;

#注文日時を表示するなら「1」、しないなら「0」
our $disp_date = 1 ;

#商品名を表示するなら「1」、しないなら「0」
our $disp_product  = 1 ;

#サムネイルを表示するなら「1」、しないなら「0」
our $disp_thumbnail  = 1 ;

#商品ページURLを表示するなら「1」、しないなら「0」
our $disp_url  = 1 ;

#都道府県を表示するなら「1」、しないなら「0」
our $disp_pref  = 1 ;

#注文金額を表示するなら「1」、しないなら「0」
our $disp_price  = 1 ;

#更新日時を表示するなら「1」、しないなら「0」
our $disp_update = 1 ;

#デザインテンプレートファイル名
our $temp_file = 'template.html' ;

#注文データを表示する件数の上限（下の注文データ保存数より小さい数を指定）
our $max_disp = 50 ;

#◆FTP転送設定（楽天GOLDのアカウント）

#FTPサーバー
our $ftp_server = 'ftp.rakuten.ne.jp' ;

#ユーザー名
our $ftp_user = 'rakutenname' ;

#パスワード
our $ftp_pass = "rakutenpass";

#転送先ディレクトリ（例：/gyoretsu/）
our $ftp_dir = '/gyoretsu/' ;

#◆その他の設定

#ショップID（ショップのトップページ等でキーワード空欄で「ショップ内検索」ボタンを押すと表示されるページのURL「http://search.rakuten.co.jp/search/inshop-mall/-/-/sid.******-st.A」の「******」にある6ケタの数字です）
our $sid = '123456' ;

#注文データ保存ファイル名
our $order_csv = 'order.csv' ;

#注文データを保存する件数の上限（上の注文データ表示数より大きい数を指定。超えると古いデータから削除されます。）
our $max_csv = 100 ;

#Cronで起動させる場合は「1」、imgタグで起動する場合は「0」
our $start_cron = 1 ;

1;
